document.addEventListener("DOMContentLoaded", function() {
    var hideElements = document.querySelectorAll('#main .wrapper_separator .col-option[data-column-parent], #main .wrapper_stop .col-option[data-column-parent]');
    for (var i = 0; i < hideElements.length; i++) {
      hideElements[i].closest('.tl_content').classList.add('hide-buttons');
    }

    // ======================= //
    // row visibility toggler fix
    // ======================= //
    var wrappers = document.querySelectorAll('#main .wrapper_start, #main .wrapper_separator, #main .wrapper_stop');
    var wrapperTogglers = document.querySelectorAll('#main .wrapper_start a.toggle, #main .wrapper_separator a.toggle, #main .wrapper_stop a.toggle');

    function toggleElCols(columnParent, state) {
      for (var i = 0; i < wrappers.length; i++) {
        var colOption = wrappers[i].querySelectorAll('.col-option[data-column-parent="'+columnParent+'"]');
        if(colOption) {
          var cteType = wrappers[i].querySelectorAll('.cte_type')[0];
          var toggleImg = wrappers[i].querySelectorAll('.toggle img')[0];
          console.log(cteType);
          if (state === "publish") {
            cteType.classList.remove('unpublished');
            cteType.classList.add('published');
            toggleImg.src = "system/themes/flexible/icons/visible.svg";
          } else {
            cteType.classList.remove('published');
            cteType.classList.add('unpublished');
            toggleImg.src = "system/themes/flexible/icons/invisible.svg";
          }
        }
      }
    }
    if (wrapperTogglers) {
    	for (var i = 0; i < wrapperTogglers.length; i++) {
    		wrapperTogglers[i].addEventListener("click", function(ele){
          var tlContent = ele.srcElement.closest('.tl_content'),
              colOption = tlContent.querySelectorAll('.col-option')[0],
              colOption = tlContent.querySelectorAll('.cte_type')[0];
          if (colOption.classList.contains('published')) {
            state = 'publish';
          } else {
            state = 'unpublish';
          }
    			toggleElCols(colOption.dataset.columnParent, state);
    		});
    	}
    }

  // ======================= //
  // color
  // ======================= //
  var ecColorInput = document.getElementById('ctrl_column_color');
  if (ecColorInput) {
    var divColorPrev = document.createElement("div");
    divColorPrev.classList.add("color-preview");
    ecColorInput.parentElement.append(divColorPrev);
    divColorPrev.style.background = '#'+ecColorInput.value;

    // on input change
    ecColorInput.addEventListener('input', function (evt) {
        divColorPrev.style.background = '#'+ecColorInput.value
    });

    // when color is changed by colorpicker
    var ctrlColorButton = document.querySelectorAll('#ctrl_column_color .moor-okButton');
    ctrlColorButton[0].onclick = function(){
        divColorPrev.style.background = '#'+ecColorInput.value
    };
  }

  // ======================= //
  // cols preview
  // ======================= //
  	// functions
  	function updateCols(container) {
  		// cols
  		var cols = container.querySelectorAll('.cols_preview .col');

  		var widths = container.querySelectorAll('select[id*="_width"]');
  		var offsets = container.querySelectorAll('select[id*="_offset"]');
  		var aligns = container.querySelectorAll('select[id*="_align"]');
  		var orders = container.querySelectorAll('select[id*="_order"]');

  		for (var i = 0; i < cols.length; i++) {
  			var colClass = 'col colsPart_'+(parseInt(i)+1);
  			// width
  		  var widthTxt = widths[i].value;
  			if (widthTxt === 'auto') {
  				colClass += ' col-sm';
  			} else {
  				colClass += ' col-sm-'+widthTxt;
  			}
  			// offset
  		  var offsetTxt = offsets[i].value;
  			if (offsetTxt) {
  				colClass += ' col-sm-offset-'+offsetTxt;
  			}
  			// align
  		  var alignTxt = aligns[i].value;
  			if (alignTxt) {
  				colClass += ' col-sm-align-'+alignTxt;
  			}
  			// order
  		  var orderTxt = orders[i].value;
  			if (orderTxt) {
  				colClass += ' col-sm-order-'+orderTxt;
  			}

  			cols[i].setAttribute('class', colClass);
  		}
  	}
  	function updateRow() {
  		var justify = document.getElementById('ctrl_column_justify');
  		var align = document.getElementById('ctrl_column_align');
  		// rows
  		var allRows = container.querySelectorAll('.widget-columns-container .row');
  		for (var i = 0; i < allRows.length; i++) {
  			var rowClass = 'row';
  			if (justify.value) {
  				rowClass += ' justify-'+justify.value;
  			}
  			if (align.value) {
  				rowClass += ' align-'+align.value;
  				rowClass += ' align_preview_fix';
  			}
  			allRows[i].setAttribute('class', rowClass);
  		}
  	}



  	// Create preview container
  	var columnsContainer = document.getElementsByClassName('widget-columns-container');

  	for (colContainerIndex = 0; colContainerIndex < columnsContainer.length; ++colContainerIndex) {
  		// container
  		divColsPreview = document.createElement('div');
  		divColsPreview.setAttribute('class', 'cols_preview');
  		columnsContainer[colContainerIndex].appendChild(divColsPreview);

  		// row
  		divColsPreviewRow = document.createElement('div');
  		divColsPreviewRow.setAttribute('class', 'row');
  		divColsPreview.appendChild(divColsPreviewRow);

  		// cols
  		var tr = columnsContainer[colContainerIndex].querySelectorAll('tbody > tr');
  		for (trIndex = 0; trIndex < tr.length; ++trIndex) {
  			col = document.createElement('div');
  			col.setAttribute('class', 'col colsPart_' + (trIndex+1));
  			col.innerHTML = '<div class="box"><p class="col_index">' + (trIndex+1) + '</p></div>';

  			divColsPreviewRow.appendChild(col);
  		}

  		// call functions on start
  		updateCols(columnsContainer[colContainerIndex]);
  		updateRow();
  	}

  	// call functions when any select is changed
  	var selects = document.querySelectorAll('.widget-columns-container select');
    if (selects) {
    	for (var selectIndex = 0; selectIndex < selects.length; selectIndex++) {
    		selects[selectIndex].addEventListener("change", function(ele){
    			var parent = ele.srcElement.closest(".widget-columns-container");
    			updateCols(parent);
    		});
    	}
    }
  	var selectJustify = document.getElementById('ctrl_column_justify');
    if (selectJustify) {
    	selectJustify.addEventListener("change", function(){
    		updateRow();
    	});
    }
  	var selectAlign = document.getElementById('ctrl_column_align');
    if (selectAlign) {
    	selectAlign.addEventListener("change", function(){
    		updateRow();
    	});
    }
});
